//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

///-*- c++ -*-////////////////////////////////////////////////////////
// Exception.h - base class for all FUNSSEL exception
// $Id: Exception.h,v 1.2 2001/09/11 10:08:37 goetz Exp $
// Time-stamp: <2001-01-14 15:03:14 goetz>
//////////////////////////////////////////////////////////////////////

#ifndef EXCEPTION_H
#define EXCEPTION_H

#include <string>

class Exception
{
 public:
  Exception() {};

  Exception( const string & descr ) : descr(descr) {};
  string descr;
};

class ostream & operator<< (class ostream &, const Exception &);
#endif
