// -*- c++ -*- /////////////////////////////////////////////////
//
// $Id: trainer.h,v 1.3 2001/09/20 15:16:08 satan Exp $
//
// trainer.h
//
////////////////////////////////////////////////////////////////

#ifndef _TRAINER_H_
#define _TRAINER_H_

#include <unistd.h>
#include "coach.h"
#include "snapshot.h"


class Trainer : public Coach {
  
public:
  
  Trainer (const char*  team,
	   playing_side side,
	   const char*  host         = DEFAULT_HOST,
	   int          port         = COACH_PORT,
	   const char*  configfile   = "agent.conf",
	   double       MapWindowMagnify = 0,
	   bool         logging      = false);
  
  virtual void act(Snapshot* snap);
  
private:
  
  char playername [MAX_SERVER_MSG_SIZE];

};

#endif
