/* This file is included by Parser.C */

/** Parameters sent by the server. Dont't mix up the sequence!
 */

/* awk '/[:blank:]*{.*,$/{ print t $0; t+=1 }; /^$/ {t=1}' ParserStrings.C 
 */

Parser::Token
Parser::serverParamTokens[] = {
  {" (catch_ban_cycle %d)%n",
   (void*)&CATCH_BAN_CYCLES,
   DT_INT
  },
  {" (clang_advice_win %d)%n",
   (void*)&CLANG_ADVICE_WIN,
   DT_INT
  },
  {" (clang_define_win %d)%n",
   (void*)&CLANG_DEFINE_WIN,
   DT_INT
  },
  {" (clang_del_win %d)%n",
   (void*)&CLANG_DEL_WIN,
   DT_INT
  },
  {" (clang_info_win %d)%n",
   (void*)&CLANG_INFO_WIN,
   DT_INT
  },
  {" (clang_mess_delay %d)%n",
   (void*)&CLANG_MESS_DELAY,
   DT_INT
  },
  {" (clang_mess_per_cycle %d)%n",
   (void*)&CLANG_MESS_PER_CYCLE,
   DT_INT
  },
  {" (clang_meta_win %d)%n",
   (void*)&CLANG_META_WIN,
   DT_INT
  },
  {" (clang_rule_win %d)%n",
   (void*)&CLANG_RULE_WIN,
   DT_INT
  },
  {" (clang_win_size %d)%n",
   (void*)&CLANG_WIN_SIZE,
   DT_INT
  },
  {" (coach_port %*d)%n",
   NULL,
   DT_NONE
  },
  {" (drop_ball_time %d)%n",
   (void*)&DROP_BALL_TIME,
   DT_INT
  },
  {" (freeform_send_period %*d)%n",
   NULL,
   DT_NONE
  },
  {" (freeform_wait_period %*d)%n",
   NULL,
   DT_NONE
  },
  {" (game_log_compression %*d)%n",
   NULL,
   DT_NONE
  },
  {" (game_log_version %*d)%n",
   NULL,
   DT_NONE
  },
  {" (goalie_max_moves %d)%n",
   (void*)&GOALIE_MAX_MOVES,
   DT_INT
  },
  {" (half_time %d)%n",
   (void*)&HALF_TIME,
   DT_INT
  },
  {" (hear_decay %lf)%n",
   (void*)&HEAR_DECAY,
   DT_DOUBLE
  },
  {" (hear_inc %lf)%n",
   (void*)&HEAR_INC,
   DT_DOUBLE
  },
  {" (hear_max %lf)%n",
   (void*)&HEAR_MAX,
   DT_DOUBLE
  },
  {" (max_goal_kicks %*d)%n",
   NULL,
   DT_NONE
  },
  {" (olcoach_port %*d)%n",
   NULL,
   DT_NONE
  },
  {" (point_to_ban %d)%n",
   (void*)&POINTTO_BAN_CYCLES,
   DT_INT
  },
  {" (point_to_duration %d)%n",
   (void*)&POINTTO_DURATION,
   DT_INT
  },
  {" (port %*d)%n",
   NULL,
   DT_NONE
  },
  {" (recv_step %d)%n",
   (void*)&RECV_STEP,
   DT_INT
  },
  {" (say_coach_cnt_max %d)%n",
   (void*)&SAY_COACH_CNT_MAX,
   DT_INT
  },
  {" (say_coach_msg_size %d)%n",
   (void*)&SAY_COACH_MSG_SIZE,
   DT_INT
  },
  {" (say_msg_size %d)%n",
   (void*)&SAY_MSG_SIZE,
   DT_INT
  },
  {" (send_step %d)%n",
   (void*)&SEND_STEP,
   DT_INT
  },
  {" (send_vi_step %d)%n",
   (void*)&SEND_VI_STEP,
   DT_INT
  },
  {" (sense_body_step %d)%n",
   (void*)&SENSE_BODY_STEP,
   DT_INT
  },
  {" (simulator_step %d)%n",
   (void*)&SIMULATOR_STEP,
   DT_INT
  },
  {" (slow_down_factor %d)%n",
   (void*)&SLOW_DOWN_FACTOR,
   DT_INT
  },
  {" (start_goal_l %*d)%n",
   NULL,
   DT_NONE
  },
  {" (start_goal_r %*d)%n",
   NULL,
   DT_NONE
  },
  {" (synch_micro_sleep %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (synch_offset %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (tackle_cycles %d)%n",
   (void*)&TACKLE_CYCLES,
   DT_INT
  },
  {" (text_log_compression %*d)%n",
   NULL,
   DT_NONE
  },
  {" (game_log_dir%*[^)])%n",
   NULL,
   DT_NONE
  },
  {" (game_log_fixed_name%*[^)])%n",
   NULL,
   DT_NONE
  },
  {" (landmark_file%*[^)])%n",
   NULL,
   DT_NONE
  },
  {" (log_date_format%*[^)])%n",
   NULL,
   DT_NONE
  },
  {" (text_log_dir%*[^)])%n",
   NULL,
   DT_NONE
  },
  {" (text_log_fixed_name%*[^)])%n",
   NULL,
   DT_NONE
  },
  {" (coach %*d)%n",
   NULL,
   DT_NONE
  },
  {" (coach_w_referee %*d)%n",
   NULL,
   DT_NONE
  },
  {" (old_coach_hear %*d)%n",
   NULL,
   DT_NONE
  },
  {" (wind_none %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (wind_random %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (back_passes %*d)%n",
   NULL,
   DT_NONE
  },
  {" (forbid_kick_off_offside %hd)%n",
   (void*)&FORBID_KICK_OFF_OFFSIDE,
   DT_BOOL
  },
  {" (free_kick_faults %*d)%n",
   NULL,
   DT_NONE
  },
  {" (fullstate_l %*d)%n",
   NULL,
   DT_NONE
  },
  {" (fullstate_r %*d)%n",
   NULL,
   DT_NONE
  },
  {" (game_log_dated %*d)%n",
   NULL,
   DT_NONE
  },
  {" (game_log_fixed %*d)%n",
   NULL,
   DT_NONE
  },
  {" (game_logging %*d)%n",
   NULL,
   DT_NONE
  },
  {" (log_times %*d)%n",
   NULL,
   DT_NONE
  },
  {" (profile %*d)%n",
   NULL,
   DT_NONE
  },
  {" (proper_goal_kicks %*d)%n",
   NULL,
   DT_NONE
  },
  {" (record_messages %*d)%n",
   NULL,
   DT_NONE
  },
  {" (send_comms %*d)%n",
   NULL,
   DT_NONE
  },
  {" (synch_mode %hd)%n",
   (void*)&SYNCH_MODE,
   DT_BOOL
  },
  {" (team_actuator_noise %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (text_log_dated %*d)%n",
   NULL,
   DT_NONE
  },
  {" (text_log_fixed %*d)%n",
   NULL,
   DT_NONE
  },
  {" (text_logging %*d)%n",
   NULL,
   DT_NONE
  },
  {" (use_offside %hd)%n",
   (void*)&USE_OFFSIDE,
   DT_BOOL
  },
  {" (verbose %*d)%n",
   NULL,
   DT_NONE
  },
  {" (audio_cut_dist %lf)%n",
   (void*)&AUDIO_CUT_DIST,
   DT_DOUBLE
  },
  {" (ball_accel_max %lf)%n",
   (void*)&BACCEL_MAX,
   DT_DOUBLE
  },
  {" (ball_decay %lf)%n",
   (void*)&BALL_DECAY,
   DT_DOUBLE
  },
  {" (ball_rand %lf)%n",
   (void*)&BALL_RAND,
   DT_DOUBLE
  },
  {" (ball_size %lf)%n",
   (void*)&BALL_SIZE,
   DT_DOUBLE
  },
  {" (ball_speed_max %lf)%n",
   (void*)&BALL_SPEED_MAX,
   DT_DOUBLE
  },
  {" (ball_weight %lf)%n",
   (void*)&BALL_WEIGHT,
   DT_DOUBLE
  },
  {" (catch_probability %lf)%n",
   (void*)&CATCH_PROBABILITY,
   DT_DOUBLE
  },
  {" (catchable_area_l %lf)%n",
   (void*)&CATCHABLE_AREA_L,
   DT_DOUBLE
  },
  {" (catchable_area_w %lf)%n",
   (void*)&CATCHABLE_AREA_W,
   DT_DOUBLE
  },
  {" (ckick_margin %lf)%n",
   (void*)&CKICK_MARGIN,
   DT_DOUBLE
  },
  {" (control_radius %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (dash_power_rate %lf)%n",
   (void*)&DASH_POWER_RATE,
   DT_DOUBLE
  },
  {" (effort_dec %lf)%n",
   (void*)&EFFORT_DEC,
   DT_DOUBLE
  },
  {" (effort_dec_thr %lf)%n",
   (void*)&EFFORT_DEC_THR,
   DT_DOUBLE
  },
  {" (effort_inc %lf)%n",
   (void*)&EFFORT_INC,
   DT_DOUBLE
  },
  {" (effort_inc_thr %lf)%n",
   (void*)&EFFORT_INC_THR,
   DT_DOUBLE
  },
  {" (effort_init %*d)%n",
   NULL,
   DT_NONE
  },
  {" (effort_min %lf)%n",
   (void*)&EFFORT_MIN,
   DT_DOUBLE
  },
  {" (goal_width %lf)%n",
   (void*)&GOAL_WIDTH,
   DT_DOUBLE
  },
  {" (inertia_moment %lf)%n",
   (void*)&INERTIA_MOMENT,
   DT_DOUBLE
  },
  {" (kick_power_rate %lf)%n",
   (void*)&KICK_POWER_RATE,
   DT_DOUBLE
  },
  {" (kick_rand %lf)%n",
   (void*)&KICK_RAND,
   DT_DOUBLE
  },
  {" (kick_rand_factor_l %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (kick_rand_factor_r %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (kickable_margin %lf)%n",
   (void*)&KICKABLE_MARGIN,
   DT_DOUBLE
  },
  {" (maxmoment %lf)%n",
   (void*)&MAXMOMENT,
   DT_DOUBLE
  },
  {" (maxneckang %lf)%n",
   (void*)&MAXNECKANG,
   DT_DOUBLE
  },
  {" (maxneckmoment %lf)%n",
   (void*)&MAXNECKMOMENT,
   DT_DOUBLE
  },
  {" (maxpower %lf)%n",
   (void*)&MAXPOWER,
   DT_DOUBLE
  },
  {" (minmoment %lf)%n",
   (void*)&MINMOMENT,
   DT_DOUBLE
  },
  {" (minneckang %lf)%n",
   (void*)&MINNECKANG,
   DT_DOUBLE
  },
  {" (minneckmoment %lf)%n",
   (void*)&MINNECKMOMENT,
   DT_DOUBLE
  },
  {" (minpower %lf)%n",
   (void*)&MINPOWER,
   DT_DOUBLE
  },
  {" (offside_active_area_size %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (offside_kick_margin %lf)%n",
   (void*)&OFFSIDE_KICK_MARGIN,
   DT_DOUBLE
  },
  {" (player_accel_max %lf)%n",
   (void*)&PLAYER_ACCEL_MAX,
   DT_DOUBLE
  },
  {" (player_decay %lf)%n",
   (void*)&PLAYER_DECAY,
   DT_DOUBLE
  },
  {" (player_rand %lf)%n",
   (void*)&PLAYER_RAND,
   DT_DOUBLE
  },
  {" (player_size %lf)%n",
   (void*)&PLAYER_SIZE,
   DT_DOUBLE
  },
  {" (player_speed_max %lf)%n",
   (void*)&PLAYER_SPEED_MAX,
   DT_DOUBLE
  },
  {" (player_weight %lf)%n",
   (void*)&PLAYER_WEIGHT,
   DT_DOUBLE
  },
  {" (prand_factor_l %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (prand_factor_r %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (quantize_step %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (quantize_step_l %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (recover_dec %lf)%n",
   (void*)&RECOVER_DEC,
   DT_DOUBLE
  },
  {" (recover_dec_thr %lf)%n",
   (void*)&RECOVER_DEC_THR,
   DT_DOUBLE
  },
  {" (recover_min %lf)%n",
   (void*)&RECOVER_MIN,
   DT_DOUBLE
  },
  {" (slowness_on_top_for_left_team %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (slowness_on_top_for_right_team %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (stamina_inc_max %lf)%n",
   (void*)&STAMINA_INC_MAX,
   DT_DOUBLE
  },
  {" (stamina_max %lf)%n",
   (void*)&STAMINA_MAX,
   DT_DOUBLE
  },
  {" (stopped_ball_vel %*lf)%n",
   NULL,
   DT_NONE
  },
  {" (tackle_back_dist %lf)%n",
   (void*)&TACKLE_BACK_DIST,
   DT_DOUBLE
  },
  {" (tackle_dist %lf)%n",
   (void*)&TACKLE_DIST,
   DT_DOUBLE
  },
  {" (tackle_exponent %d)%n",
   (void*)&TACKLE_EXP,
   DT_INT
  },
  {" (tackle_power_rate %lf)%n",
   (void*)&TACKLE_POWER_RATE,
   DT_DOUBLE
  },
  {" (tackle_width %lf)%n",
   (void*)&TACKLE_WIDTH,
   DT_DOUBLE
  },
  {" (visible_angle %lf)%n",
   (void*)&VISIBLE_ANGLE,
   DT_DOUBLE
  },
  {" (visible_distance %lf)%n",
   (void*)&VISIBLE_DISTANCE,
   DT_DOUBLE
  },
  {" (wind_ang %lf)%n",
   (void*)&WIND_ANGLE,
   DT_DOUBLE
  },
  {" (wind_dir %lf)%n",
   (void*)&WIND_DIR,
   DT_DOUBLE
  },
  {" (wind_force %lf)%n",
   (void*)&WIND_FORCE,
   DT_DOUBLE
  },
  {" (wind_rand %lf)%n",
   (void*)&WIND_RAND,
   DT_DOUBLE
  },
  {NULL, NULL, DT_NONE} // to determine the last entry
};

Parser::Token
Parser::playerParamTokens[] = {
  {" (player_types %d)%n",
   (void*)&playerParams.player_types,
   DT_INT
  },
  {" (pt_max %lf)%n",
   (void*)&playerParams.pt_max,
   DT_DOUBLE
  },
  {" (random_seed %*d)%n",
   NULL,
   DT_NONE
  },
  {" (subs_max %d)%n",
   (void*)&playerParams.subs_max,
   DT_INT
  },
  {" (dash_power_rate_delta_max %lf)%n",
   (void*)&playerParams.dash_power_rate_delta_max,
   DT_DOUBLE
  },
  {" (dash_power_rate_delta_min %lf)%n",
   (void*)&playerParams.dash_power_rate_delta_min,
   DT_DOUBLE
  },
  {" (effort_max_delta_factor %lf)%n",
   (void*)&playerParams.effort_max_delta_factor,
   DT_DOUBLE
  },
  {" (effort_min_delta_factor %lf)%n",
   (void*)&playerParams.effort_min_delta_factor,
   DT_DOUBLE
  },
  {" (extra_stamina_delta_max %lf)%n",
   (void*)&playerParams.extra_stamina_delta_max,
   DT_DOUBLE
  },
  {" (extra_stamina_delta_min %lf)%n",
   (void*)&playerParams.extra_stamina_delta_min,
   DT_DOUBLE
  },
  {" (inertia_moment_delta_factor %lf)%n",
   (void*)&playerParams.inertia_moment_delta_factor,
   DT_DOUBLE
  },
  {" (kick_rand_delta_factor %lf)%n",
   (void*)&playerParams.kick_rand_delta_factor,
   DT_DOUBLE
  },
  {" (kickable_margin_delta_max %lf)%n",
   (void*)&playerParams.kickable_margin_delta_max,
   DT_DOUBLE
  },
  {" (kickable_margin_delta_min %lf)%n",
   (void*)&playerParams.kickable_margin_delta_min,
   DT_DOUBLE
  },
  {" (new_dash_power_rate_delta_max %lf)%n",
   (void*)&playerParams.new_dash_power_rate_delta_max,
   DT_DOUBLE
  },
  {" (new_dash_power_rate_delta_min %lf)%n",
   (void*)&playerParams.new_dash_power_rate_delta_min,
   DT_DOUBLE
  },
  {" (new_stamina_inc_max_delta_factor %lf)%n",
   (void*)&playerParams.new_stamina_inc_max_delta_factor,
   DT_DOUBLE
  },
  {" (player_decay_delta_max %lf)%n",
   (void*)&playerParams.player_decay_delta_max,
   DT_DOUBLE
  },
  {" (player_decay_delta_min %lf)%n",
   (void*)&playerParams.player_decay_delta_min,
   DT_DOUBLE
  },
  {" (player_size_delta_factor %lf)%n",
   (void*)&playerParams.player_size_delta_factor,
   DT_DOUBLE
  },
  {" (player_speed_max_delta_max %lf)%n",
   (void*)&playerParams.player_speed_max_delta_max,
   DT_DOUBLE
  },
  {" (player_speed_max_delta_min %lf)%n",
   (void*)&playerParams.player_speed_max_delta_min,
   DT_DOUBLE
  },
  {" (stamina_inc_max_delta_factor %lf)%n",
   (void*)&playerParams.stamina_inc_max_delta_factor,
   DT_DOUBLE
  },
  {NULL, NULL, DT_NONE} // to determine the last entry
};
